#from __future__ import unicode_literals
# -*- coding: utf-8 -*-
from __future__ import division

from PyQt4.QtCore import *
from PyQt4.QtGui import *

from Terrain import Terrain

from ui.ecran_editionTerrain import Ui_editionTerrain

from outilsSvg import *

class EcranEditionTerrain(QDialog):
    """interface de creation/edition de terrains"""
    def __init__(self, terrain=None, parent=None):
        """initialisation de la fenetre"""
        super (EcranEditionTerrain, self).__init__()
        self.createWidgets()
        self.terrain = terrain
        if terrain == None:
            self.accesCreation()
        else:
            self.accesEdition()
        self.majAffichage("")    
        
    def createWidgets(self):
        """construction de l'interface"""
        #construction de l'interface
        self.ui = Ui_editionTerrain()
        self.ui.setupUi(self)
        self.connect(self.ui.enregistrerTerrain, SIGNAL("clicked()"), self.enregistrer)
        self.connect(self.ui.annulerTerrain, SIGNAL("clicked()"), self.annuler)
        self.connect(self.ui.supprimerTerrain, SIGNAL("clicked()"), self.supprimer)
        self.connect(self.ui.idTerrain, SIGNAL("textEdited(QString)"), self.majAffichage)
        self.connect(self.ui.nomTerrain, SIGNAL("textEdited(QString)"), self.majAffichage)
        self.connect(self.ui.couleurTerrain, SIGNAL("clicked()"), self.selectionCouleur)
        
    def accesEdition(self):
        """ouverture en mode edition"""
        self.ui.idTerrain.setEnabled(True)
       
        self.ui.idTerrain.setText(QString.fromUtf8(str(self.terrain.id)))
        self.ui.nomTerrain.setText(QString.fromUtf8(str(self.terrain.nom)))        
        if self.terrain.couleur.isValid():
            self.ui.affichageCouleurTerrain.setStyleSheet("QLabel {backGround:%s}" %(self.terrain.couleur.name()))
        self.ui.imgTextureTerrain.setText(QString.fromUtf8(str(self.terrain.imgTexture)))      
        self.ui.modDeplacementTerrain.setValue(self.terrain.modDeplacement)
        if self.terrain.visibilite:
            self.ui.visibiliteTerrain.setCheckState(2)
        else:
            self.ui.visibiliteTerrain.setCheckState(0)
        if self.terrain.franchissable:    
            self.ui.franchissableTerrain.setCheckState(2)
        else:
            self.ui.franchissableTerrain.setCheckState(0)
        self.ui.supprimerTerrain.setEnabled(True)
        self.ui.idTerrain.setEnabled(False)

    def accesCreation(self):
        """ouverture en mode creation"""
        self.terrain = Terrain()
        self.ui.idTerrain.setEnabled(True)
        self.ui.idTerrain.setText(QString.fromUtf8(str(self.nouvelIdTerrain())))
        self.ui.idTerrain.setEnabled(False)

    def majAffichage(self, txt):
        """verifie la validite des saisies"""
        self.ui.enregistrerTerrain.setEnabled(len(self.ui.idTerrain.text().toUtf8()) > 0 and len(self.ui.nomTerrain.text().toUtf8()) > 0)

    def nouvelIdTerrain(self):
        """renvoie un identifiant pour un nouveau terrain"""
        dicoSvg = afficheSvg("lib\\biblio\\terrain")
        nouvelId = 1
        while str(nouvelId) in dicoSvg.keys():
            nouvelId += 1
        return str(nouvelId)

    def selectionCouleur(self):
        """selectionne la couleur dans la boite de dialogue dediee"""
        couleur = QColorDialog(self).getColor(QColor("white"), self)
        if couleur.isValid():
            nomCouleur = couleur.name()
            self.ui.affichageCouleurTerrain.setStyleSheet("QLabel {backGround:%s}" %(nomCouleur))
            self.terrain.couleur = couleur    
            
    def enregistrer(self):
        """enregistre le terrain cree/edite"""
        self.terrain.id = str(self.ui.idTerrain.text().toUtf8())
        self.terrain.nom = str(self.ui.nomTerrain.text().toUtf8())
        self.terrain.imgTexture = str(self.ui.imgTextureTerrain.text().toUtf8())
        self.terrain.modDeplacement = float(self.ui.modDeplacementTerrain.value())
        self.terrain.visibilite = bool(self.ui.visibiliteTerrain.checkState())
        self.terrain.franchissable = bool(self.ui.franchissableTerrain.checkState())
        enregistrer(self.terrain.id, self.terrain, "lib\\biblio\\terrain")
        self.terrain = None
        self.close()
        self.emit(SIGNAL("majListTerrains()"))

    def supprimer(self):
        """supprimer l'enregistrement de ce terrain"""
        supprSvg("terrain", self.terrain.id)
        self.close()
        self.emit(SIGNAL("majListTerrains()"))

    def annuler(self):
        """annule la creation/edition"""
        self.terrain = None
        self.close()
